-------------[[[[[Mario Engine]]]]]-------------
-------------[[[[[Written by dan369]]]]]-------------
-------------[[[[[For PSP]]]]]-------------

--[[
This is a platformer engine that i'm writing to make a platform game, i want it to be as re-usable as possible. I call it the Mario Engine because
Mario is the good of all platforming games, it set the standard. So thats the reason behind the name choice. It will be written for the PGE API.
It will use Tilemaps, and tile-based collision for the basic features. Another aspect is to make it as easy as possible to create a level.

Update 24th august 09:
Succesfully started to create a 2d mario clone, using the above features & trying to stick to the criteria above.
Most things done, first release is incoming. Adding polishing touches now & the last few features before a release.
Release expected beore i finsh the 6 weeks holidays.

Update 10th October 09:
Haven't done hardly any work on this in weeks, finally doing something. Added the gameover screen & fixed stupid collision bug. 
The stupid death bug is there, can't seem to solve it :S. But i will.
Gunna add Koopas hopefully.
]]--

----Load Tilesheet
tilesheet = pge.texture.load("Content/GFX/tileset.png", PGE_VRAM);
miniBlock = pge.texture.load("Content/GFX/mini-block.png", PGE_RAM);
miniCoins = pge.texture.load("Content/GFX/mini-coins.png", PGE_RAM);
Coins = pge.texture.load("Content/GFX/coins.png", PGE_RAM);

--Load file for restarting a game when lives < 0.
restart = loadfile("script.lua");

----Load Sounds
Jump = pge.wav.load("Content/SFX/jump.wav");
die = pge.wav.load("Content/SFX/die.wav");
smash = pge.wav.load("Content/SFX/smash.wav");
stomp = pge.wav.load("Content/SFX/stomp.wav");
pause = pge.wav.load("Content/SFX/pause.wav");
warning = pge.wav.load("Content/SFX/warning.wav");
gameover = pge.wav.load("Content/SFX/gameover.wav");
kick = pge.wav.load("Content/SFX/kick.wav");
coin = pge.wav.load("Content/SFX/coin.wav");
musicIsPlaying = false;
warningPlayed = false;
gameOverPlayed = false;
deathCounter = 0;
gameOverCounter = 0;

----Intial variables used for Tilemap
scr_left = 0; ---screen left offset
scr_top = 0;  ---screen top offset
scrSpeed = 2; --scroll speed
currentFrame = 1; ---current frame
frameSkip = 2; ---frameskip
tsize = 16; ---tile size
screeNum = 0;  ---screenshot number
maxTilesPerRow = (tilesheet:width() / tsize) - 1; 

--Enemie Types
enemyTypeGoomba = 3;
enemyTypeKoopaGreen = 4;
enemyTypeKoopaRed = 5;

--Create table to hold mini-block info.
miniBlocks = {};

--Create color
backCol = pge.gfx.createcolor(92, 148, 252); 

--Gamestate Constants
Start = 0;
Play = 1;
Pause = 2;
GameOver = 4;
State = Start;

--Tile constants
QuestionBlock = 4;
BlankBlock = 7;
BrickBlock = 2;

----Animation variables, for our animations
--Constants again, interchange depending on current postition/status.
Right = 1;   
Left = 0;
StandingL = 0; 
StandingR = 1;
JumpingR = 8;
JumpingL = 9;
WalkingR = 2;
WalkingL = 5;
Dead = 10;
TurningRight = 11;
TurningLeft = 12;
GrapRight = 13;
GrapLeft = 14;
direction = Right;  ---holds the current direction
turning = false; --bool for turning, to slow the wlking/running down when changing direction
oldDirection = direction;  --holds the last direction the player is moving in each frame;
currentSpirte = StandingR;  ---holds the current spirte (where to start clipping from)
currentSpirteEnd = 15;    ---this is the width of our image(to end the clipping) i do it manually because of drifferent sized spirtes.

--Koopa Anim constants
Koopa_Left = 0;
Koopa_Shell_Legs = 2;
Koopa_Right = 4;
Koopa_Shell = 3;

--Koopa Modes
Koopa_Mode_Normal = 0;
Koopa_Mode_Shell = 1;
Koopa_Mode_Hybrid = 2;

--Mario Animation tables, needed for my animation mini-libray.
MarioAnimRight = {AnimTime = 0, startFrame = WalkingR, endFrame = 5, oldFrame = WalkingR};   ---right animation table
MarioAnimLeft = {AnimTime = 0, startFrame = WalkingL, endFrame = 8, oldFrame = WalkingL};    ---left animation table
MaxTime = 6;   ---MaxTime between frames.
offset = 0;  ---offset required for certain images.

--Mario States
Small = 0;
Big = 1;

--Table to hold animtion blocks info.
animBlocks = {};

--Level Info for HUD
OverWorld = 1;
UnderWorld = 2;
current = {level = "1-1", levelNum = 1, lType = OverWorld, Time = pge.timer.create()};
totalTime = 400;
splashCounter = 0;

--Mini-coins animation table.
MiniCoins = {AnimTime = 0, startFrame = 0, endFrame = 3, oldFrame = 0};

--Checkpoint table
Checkpoint = {};

--Flag table
flag = {};

--Score text table, to hold the score text.
scoreText = {};
multipler = 1;
scoreCount = 0;

--Function to create the 'player' table.
function createPlayerObject(X, Y, Width, Height, SpeedX, SpeedY, Jump, Img)
	if playerChose == 0 then
		Img = pge.texture.load("Content/GFX/mario.png", PGE_RAM);
	elseif playerChose == 1 then
		Img = pge.texture.load("Content/GFX/luigi.png", PGE_RAM);
	end
	
	player = {};
	player = {x =  X, y = Y, img = Img, width = Width, height = Height, speedX = SpeedX, speedY = SpeedY, jump = Jump, dead = false, lives = 3, maxSpeed = 2, coins = 00, score = 0, win = false, state = Small};
end

--Function to load a Map
function loadMap(map)
	dofile(map);
end

--Function to load a Collision File
function loadCollisionMap(map)
	dofile(map);
end

--Function to create the 'enemie' objects array. Note: Must be called AFTER loading the collision map! >.>
function createEnemieObjectsCheckPointsAndCoins(colMap)
colMap = layer2 or colMap;

	--load enemie spritesheets
	goomba = pge.texture.load("Content/GFX/goomba.png", PGE_RAM);
	koopa_green = pge.texture.load("Content/GFX/koopa_green.png", PGE_RAM);
	koopa_red = pge.texture.load("Content/GFX/koopa_red.png", PGE_RAM);
	--create table constructors
	enemies = {};
	coins = {};
	--loop through file, inserting enemie objects into the array.
	for i, row in ipairs(colMap) do
		for j, tile in ipairs(row) do
			if tile == 3 then
				table.insert(enemies, {x = tsize * (j-1), y = (tsize * (i-1))-2, width = tsize, height = 18, speedX = 1, speedY = 0, direction = 0, jump = false, AnimTime = 0, startFrame = 0, endFrame = 2, oldFrame = 0, Type = enemyTypeGoomba, alive = true, counter =0});
				--perform clean-up
				colMap[i][j] = 0;
			end
			if tile == 6 then
				table.insert(enemies, {x = tsize * (j-1), y = (tsize * (i-1))-8, width = tsize, height = 22, speedX = 1, speedY = 0, direction = 0, oldDirection = 0, jump = false, AnimTime = 0, startFrame = 0, endFrame = 0, oldFrame = currentImg, Type = enemyTypeKoopaGreen, mode = Koopa_Mode_Normal, alive = true, counter = 0, update = false, Smoving = false});
				--perform clean-up
				colMap[i][j] = 0;
			end
			if tile == 7 then
				table.insert(enemies, {x = tsize * (j-1), y = (tsize * (i-1))-8, width = tsize, height = 22, speedX = 1, speedY = 0, direction = 0, oldDirection = 0, jump = false, AnimTime = 0, startFrame = 0, endFrame = 0, oldFrame = currentImg, Type = enemyTypeKoopaRed, mode = Koopa_Mode_Normal, alive = true, counter = 0, update = false, Smoving = false});
				--perform clean-up
				colMap[i][j] = 0;
			end
			if tile == 5 then
				table.insert(Checkpoint, {x = tsize * (j-1), done = false});
				--perform clean-up
				colMap[i][j] = 0;
			end
			if tile == 8 then
				table.insert(coins, {x = tsize * (j-1), y = (tsize * (i-1)), width = 12, height = 16, speedY = 0, AnimTime = 0, startFrame = 0, endFrame = 5, oldFrame = 0, display = true, hit = false, counter = 0});
				--perform clean-up
				colMap[i][j] = 0;
			end
		end
	end
	
	--Sort the enemie table by X coordinate, from lowest to highest. 
	table.sort(enemies, 
		function(a,b) 
			return a.x<b.x;
		end
	);
end

--Function to create the 'enemie' objects array. Note: Must be called AFTER loading the collision map! >.>
function createAnimTileObjects(Map)
Map = map or Map;

	--loop through file, inserting enemie objects into the array.
	for i, row in ipairs(Map) do
		for j, tile in ipairs(row) do
			if tile.Type == 1 then
				table.insert(animBlocks, {x = j, y = i, AnimTime = 0, startFrame = 1, endFrame = 3, oldFrame = 1});
			end
			if tile.Type == 36 then
				table.insert(flag, {x = (tsize * (j-1)) + 7, y = tsize * (i-1), done = false });
				--clean-up flag, it'll get blitted later.
				Map[i][j].Type = 0;
			end
		end
	end
end

--Function to detect Movement/Jumping
function detectButtons(object)
oldDirection = direction;
if not object.dead and not object.win then
	if pge.controls.held(PGE_CTRL_RIGHT) or pge.controls.analogx() > 99 then
		direction = Right;
		movePlayer(object, 1, 0);
		scrSpeed = 2;
	elseif pge.controls.held(PGE_CTRL_LEFT) or pge.controls.analogx() < -99 then
		direction = Left;
		movePlayer(object, -1, 0);	
	end

	--if holding the right trigger then change max speed, to fake running.
	if pge.controls.held(PGE_CTRL_RTRIGGER) then
		object.maxSpeed = 3;
		scrSpeed = 3;
		MaxTime = 3;
	else 
		object.maxSpeed = 2;
		scrSpeed = 2;
		MaxTime = 6;
	end
	
	if object.speedX > object.maxSpeed then
		object.speedX = object.maxSpeed;
	end
	
	--if changed direction then reset the speed.
	if direction ~= oldDirection and not object.jump and object.speedX == 2 then
		turning = true;
	elseif direction ~= oldDirection and not object.jump and object.speedX == 3 then
		turning = true;
	end
		
	--if changed direction then reset the speed.
	if turning then
		object.speedX = object.speedX - 0.6;
		
		if object.speedX <= 0 then
			turning = false;
			object.speedX = 0;
		end
	end

	if pge.controls.pressed(PGE_CTRL_CROSS) and not object.jump then
		object.jump = true;
		Jump:play();
		object.speedY = 8.5;
	end
end

	if object.jump and not object.win then
		jump(object);
	end
	if object.y <= 3 then
		object.y = 3;
		object.speedY = -0.5;
	end
	
	if object.x <= 1 then
		object.x = 1;
	end
	if scr_left > (#map[1] * tsize - 480) then
		scr_left = (#map[1] * tsize - 480);
	end
end

--Function to get the object corners used in Collision
function getObjectCorners(x, y, object)
	down = pge.math.floor((y + object.height - 1) / tsize)+1;
	up = pge.math.floor(y / tsize)+1;
	left = pge.math.floor(x / tsize)+1;
	right = pge.math.floor((x + object.width - 1) / tsize)+1;
end

--Function to update The Player's X/Y postition
function movePlayer(object, dirx, diry, collisionmap, Map)
collisionmap = layer2;
Map = map;
local collideLeft = false;
local collideRight = false;

--update postition
if not object.dead and object.y < 245 then
	 object.x = object.x + object.speedX * dirx;
	 if object.speedY > 0 then
		 object.y = object.y + object.speedY * diry; 
	 elseif object.speedY < 0 then
		 object.y = object.y - object.speedY * diry; 
	 end		    

	getObjectCorners(object.x, object.y, object);
	if (dirx == 1) then
	  object.speedX = object.speedX + 0.3;
		if (collisionmap[down][right] == 0 and collisionmap[up][right] == 0) then
			fall(object);
			if (object.x-scr_left) > 280 then
				scr_left = scr_left + scrSpeed;
			end
		else
			object.x = ((right-1) * tsize) - object.width;
		end	
	end
	if (dirx == -1) then
	  object.speedX = object.speedX + 0.3;
		if (collisionmap[down][left] == 0 and collisionmap[up][left] == 0) then	
			fall(object);
		else
			object.x = (left * tsize);
		end
	end
	
	if (diry == 1) then
		if (collisionmap[down][left] == 0 and collisionmap[down][right] == 0) then
		else
			object.y = ((down-1) * tsize) - object.height;
			object.jump = false;
			object.speedY = 0;
		end
	end
	if (diry == -1) then
		if (collisionmap[up][left] == 0 and collisionmap[up][right] == 0) then	   
		else
			object.y = (up * tsize);
			object.speedY = -1;
		end
	end
else
	object.y = object.y - object.speedY;
end

	   if (diry == -1) and not object.dead and object.state == Big then
			if (collisionmap[up][right] == BrickBlock) then	
				Map[up][right].Type = 0;		
				collisionmap[up][right] = 0;
				smash:play();
				collideRight = true;
			elseif (collisionmap[up][left] == BrickBlock) then
				Map[up][left].Type = 0;
				collisionmap[up][left] = 0;
				smash:play();
				collideLeft = true;
			else
				collideLeft = false;
				collideRight = false;
			end
		elseif (diry == -1) and not object.dead and object.state == Small then
			if (collisionmap[up][right] == BrickBlock) and not Map[up][right].hit then	
				Map[up][right].speedY = 2;
				Map[up][right].hit = true;
			elseif (collisionmap[up][left] == BrickBlock) and not Map[up][left].hit then
				Map[up][left].speedY = 2;
				Map[up][left].hit = true;
			end
		end
			
		if #animBlocks > 0 then
		  if (diry == -1) and not object.dead and not collideLeft and not collideRight and not Map[up][right].hit then
			if (collisionmap[up][right] == QuestionBlock) then	
				Map[up][right].Type = BlankBlock;
				collisionmap[up][right] = 1;
				table.insert(coins, {x = (tsize * (right-1))+2, y = (tsize * (up-2)), width = 12, height = 16, speedY = 1, AnimTime = 0, startFrame = 0, endFrame = 5, oldFrame = 0, display = true, hit = true, counter = 0});
				object.coins = object.coins + 1;
				coin:play();
			elseif (collisionmap[up][left] == QuestionBlock) then
				Map[up][left].Type = BlankBlock;
				collisionmap[up][left] = 1;
				table.insert(coins, {x = (tsize * (left-1))+2, y = (tsize * (up-2)), width = 12, height = 16, speedY = 1, AnimTime = 0, startFrame = 0, endFrame = 5, oldFrame = 0, display = true, hit = true, counter = 0});
				object.coins = object.coins + 1;
				coin:play();
			end
		end
	end
	
	--Check if player is tounching the flag
	if object.x >= flag[1].x + 7 then
		object.win = true;
	end
	
		--Insert miniBlocks in correct places depending on whether the player collides on the right/left underneath side of block.
		if collideLeft then
			getObjectCorners(object.x, object.y, object);
			table.insert(miniBlocks, {x = ((left-1)*tsize), y = (up-2)*tsize, img = miniBlock, speedY = 7, speedX = -0.4});  --top-left
			table.insert(miniBlocks, {x = ((left-1)*tsize+10), y = (up-2)*tsize, img = miniBlock, speedY = 7, speedX = 0.4}); --top-right
			table.insert(miniBlocks, {x = ((left-1)*tsize+10), y = ((up-1)*tsize-6), img = miniBlock, speedY = 5, speedX = 0.4}); --bottom-right
			table.insert(miniBlocks, {x = ((left-1)*tsize), y = ((up-1)*tsize-6), img = miniBlock, speedY = 5, speedX = -0.4}); --bottom-left
		elseif collideRight then
			getObjectCorners(object.x, object.y, object);
			table.insert(miniBlocks, {x = ((right-1)*tsize)-4, y = (up-2)*tsize, img = miniBlock, speedY = 7, speedX = -0.4}); --top-left
			table.insert(miniBlocks, {x = ((right-1)*tsize+10)-4, y = (up-2)*tsize, img = miniBlock, speedY = 7, speedX = 0.4}); --top-right
			table.insert(miniBlocks, {x = ((right-1)*tsize+10)-4, y = ((up-1)*tsize-6), img = miniBlock, speedY = 5, speedX = 0.4}); --bottom-right
			table.insert(miniBlocks, {x = ((right-1)*tsize)-4, y = ((up-1)*tsize-6), img = miniBlock, speedY = 5, speedX = -0.4}); --bottom-left
		end
end

--Function to control Ai 
function moveEnemies(dirx, diry, enemie, collisionmap, Map)
object = player or object;
collisionmap = layer2;
Map = map;

	if enemie.Type == enemyTypeGoomba then
		if enemie.alive and enemie.startFrame ~= 2 and enemie.y < 245 then
			getObjectCorners(enemie.x+enemie.speedX*dirx, enemie.y, enemie);
		
			if (dirx == 1) then
				if (collisionmap[down][right] == 0 and collisionmap[up][right] == 0) then
					enemie.x = enemie.x + (dirx * enemie.speedX);
					fall(enemie);
				else
					enemie.x = ((right-1) * tsize) - enemie.width;
					enemie.direction = 0;
				end	
			end
			if (dirx == -1) then
				if (collisionmap[down][left] == 0 and collisionmap[up][left] == 0) then	
					enemie.x = enemie.x + (dirx * enemie.speedX);
					fall(enemie);
				else
					enemie.x = (left * tsize);
					enemie.direction = 1;
				end
			end
			if (diry == 1) and enemie.y < 225 then
			  getObjectCorners(enemie.x, enemie.y-enemie.speedY*diry, enemie);
				if (collisionmap[down][left] == 0 and collisionmap[down][right] == 0) then	
					enemie.y = enemie.y - enemie.speedY*diry;
				else
					enemie.y = ((down-1) * tsize) - enemie.height;
					enemie.jump = false;
					enemie.speedY = 0;
				end
			end
		else
			enemie.y = enemie.y - enemie.speedY;
		end
	end
	
	if enemie.Type == enemyTypeKoopaGreen then
		if enemie.alive and enemie.y < 245 then
			getObjectCorners(enemie.x+enemie.speedX*dirx, enemie.y, enemie);
			
			if (dirx == 1) then
				if (collisionmap[down][right] == 0 and collisionmap[up][right] == 0) then
					enemie.x = enemie.x + (dirx * enemie.speedX);
					fall(enemie);
				else
					enemie.x = ((right-1) * tsize) - enemie.width;
					enemie.direction = 0;
				end	
			end
			if (dirx == -1) then
				if (collisionmap[down][left] == 0 and collisionmap[up][left] == 0) then	
					enemie.x = enemie.x + (dirx * enemie.speedX);
					fall(enemie);
				else
					enemie.x = (left * tsize);
					enemie.direction = 1;
				end
			end
			if (diry == 1) and enemie.y < 225 then
			  getObjectCorners(enemie.x, enemie.y-enemie.speedY*diry, enemie);
				if (collisionmap[down][left] == 0 and collisionmap[down][right] == 0) then	
					enemie.y = enemie.y - enemie.speedY*diry;
				else
					enemie.y = ((down-1) * tsize) - enemie.height;
					enemie.jump = false;
					enemie.speedY = 0;
				end
			end
		else
			enemie.y = enemie.y - enemie.speedY;
		end
	end
	
	if enemie.Type == enemyTypeKoopaRed then
		if enemie.alive and enemie.y < 245 then
			getObjectCorners(enemie.x+enemie.speedX*dirx, enemie.y, enemie);
			
			if (dirx == 1) then
				if (collisionmap[down][right] == 0 and collisionmap[up][right] == 0) then
					enemie.x = enemie.x + (dirx * enemie.speedX);
					fall(enemie);
				else
					enemie.x = ((right-1) * tsize) - enemie.width;
					enemie.direction = 0;
				end	
			end
			if (dirx == -1) then
				if (collisionmap[down][left] == 0 and collisionmap[up][left] == 0) then	
					enemie.x = enemie.x + (dirx * enemie.speedX);
					fall(enemie);
				else
					enemie.x = (left * tsize);
					enemie.direction = 1;
				end
			end
		else
			enemie.y = enemie.y - enemie.speedY;
		end
	end
end

--Function to move the Ai and update animation & collison checking with the A.i
function updateAi(object)
object = player or object;
local maxTime = 10;

if #enemies > 1 then
	for i = 1, #enemies - 1 do
		for j = i+1, #enemies do
			if object.x - 480 < enemies[i].x then
				if enemies[i].Type == enemyTypeKoopaGreen and enemies[i].mode == Koopa_Mode_Shell and enemies[i].Smoving and enemies[i].x + enemies[i].width+2 > enemies[j].x and enemies[j].x < enemies[i].x + enemies[i].width+2 then
					table.insert(scoreText, {x = enemies[j].x, y = enemies[j].y, score = 100 * multipler, display = true, counter = 0});
					enemies[j].alive = false;
					object.score = object.score + scoreText[#scoreText].score;
					multipler = multipler + 1;
					scoreCount = 0;
				elseif enemies[j].Type == enemyTypeKoopaGreen and enemies[j].mode == Koopa_Mode_Shell and enemies[j].Smoving and enemies[i].x + enemies[i].width+2 > enemies[j].x and enemies[j].x < enemies[i].x + enemies[i].width+2 then
					table.insert(scoreText, {x = enemies[i].x, y = enemies[i].y, score = 100 * multipler, display = true, counter = 0});
					enemies[i].alive = false;
					object.score = object.score + scoreText[#scoreText].score;
					multipler = multipler + 1;
					scoreCount = 0;		
				elseif enemies[j].x < enemies[i].x + enemies[i].width+2 then
					enemies[i].direction = 0; --left
					enemies[i].update = false; --update the sprite
					enemies[j].direction = 1; --right
					enemies[j].update = false; --update the sprite
				else
					break;
				end
			end
		end
	end
end
		
if #enemies > 0 then
	for e, enemie in ipairs(enemies) do
		if enemie.Type == enemyTypeGoomba then
			if object.x + 480 > enemie.x and enemie.startFrame ~= 2 and enemie.alive and enemie.y < 225 then
				pge.gfx.animateadvanced(enemie, maxTime, enemie, enemie, true);
				--Direction, 0 = left, 1 = right;
				if enemie.direction == 0 then
					moveEnemies(-1, 0, enemie);
				elseif enemie.direction == 1 then
					moveEnemies(1, 0, enemie);
				end
			end
		--[[
		If player collides with enemie then it'll change to a 'dead' sprite. That'll start a counter off which will then 
		reach a certain int & then it'll stop displaying the enemie.
		]]--
			if enemie.startFrame == 2 then
				enemie.counter = enemie.counter +1;
			
				if enemie.counter > 60 then
					enemie.alive = false;
				end
			end

			--Check enemie collision with player object.
			if (object.y + object.height > enemie.y+2) and (object.y <= enemie.y) and (object.x + object.width > enemie.x) and (object.x < enemie.x + enemie.width) and object.speedY < 0 and object.jump and not object.dead and enemie.startFrame ~= 2 then
				object.speedY = 5;
				object.jump = true;
				stomp:play();
				table.insert(scoreText, {x = enemie.x, y = enemie.y, score = 100 * multipler, display = true, counter = 0});
				object.score = object.score + scoreText[#scoreText].score;
				multipler = multipler + 1;
				scoreCount = 0;
				enemie.startFrame = 2;
			end
		
			if (object.y-2) == enemie.y and object.x + object.width > enemie.x and object.x < enemie.x + enemie.width and not object.dead and enemie.startFrame ~= 2 then
				object.speedY = 10;
				object.jump = true;
				object.dead = true;
				death = true;
			end
		end
		
	if enemie.Type == enemyTypeKoopaGreen or enemie.Type == enemyTypeKoopaRed then	
		if object.x + 480 > enemie.x and enemie.alive and enemie.y < 225 and enemie.mode == Koopa_Mode_Normal then
			--Direction, 0 = left, 1 = right;	
			enemie.oldDirection = enemie.direction;
		
			if enemie.direction == 0 and not enemie.update then
				enemie.startFrame = Koopa_Left;
				enemie.endFrame = 2;
				enemie.oldFrame = Koopa_Left;
				enemie.update = true;
			elseif enemie.direction == 1 and not enemie.update then
				enemie.startFrame = Koopa_Right;
				enemie.endFrame = 6;
				enemie.oldFrame = Koopa_Right;
				enemie.update = true;
			end
			
			if enemie.direction == 0 then
				moveEnemies(-1, 0, enemie);
				pge.gfx.animateadvanced(enemie, 8, enemie, enemie, true);
			elseif enemie.direction == 1 then
				moveEnemies(1, 0, enemie);
				pge.gfx.animateadvanced(enemie, 8, enemie, enemie, true);
			end
			
			--Change Animation depending on direction, if the OldDirection is different to the current then it'll change accordinly, hopefully?	
			if enemie.oldDirection ~= enemie.direction then
				enemie.update = false;
			end
			
			if (object.y-6) == enemie.y and object.x + object.width > enemie.x and object.x < enemie.x + enemie.width and not object.dead then
				object.speedY = 10;
				object.jump = true;
				object.dead = true;
				death = true;
			end
			
	elseif object.x + 480 > enemie.x and enemie.alive and enemie.y < 225 and enemie.mode == Koopa_Mode_Shell then
		enemie.startFrame = Koopa_Shell;
		if enemie.speedX == 0 then
			enemie.counter = enemie.counter + 1;
		end
		
		if enemie.counter >= 120 then
			enemie.counter = 0;
			enemie.mode = Koopa_Mode_Hybrid;
		end
			
		if enemie.direction == 0 and enemie.speedX ~= 0 then
			moveEnemies(-1, 0, enemie);
		elseif enemie.direction == 1 and enemie.speedX ~= 0 then
			moveEnemies(1, 0, enemie);
		end
		
		if (object.y-6) == enemie.y and object.x + object.width > enemie.x and object.x < enemie.x + enemie.width and not object.dead and enemie.Smoving then
			object.speedY = 10;
			object.jump = true;
			object.dead = true;
			death = true;
		end

		if not object.dead and enemie.speedX == 0 then
			if (object.x + object.width > enemie.x) and (object.x < enemie.x + enemie.width) and (object.y + object.height > enemie.y+2) and (object.y <= enemie.y) and object.jump then
				object.speedY = 5;
				object.jump = true;	
				if direction == Right then
					enemie.direction = 1;
				elseif direction == Left then
					enemie.direction = 0;
				end
				enemie.speedX = 4;
				enemie.counter = 0;
				enemie.Smoving = true;
				kick:play();
			elseif (object.x + object.width > enemie.x) and (object.x < enemie.x + enemie.width) and ((object.y-6) + object.height > enemie.y) and ((object.y-6) < enemie.y + enemie.height) and object.speedY == 0 and not object.jump then
				if direction == Right then
					enemie.direction = 1;
				elseif direction == Left then
					enemie.direction = 0;
				end
				enemie.speedX = 4;
				enemie.counter = 0;
				enemie.Smoving = true;
				kick:play();
			end
		end
	elseif object.x + 480 > enemie.x and enemie.alive and enemie.y < 225 and enemie.mode == Koopa_Mode_Hybrid then
		enemie.startFrame = Koopa_Shell_Legs;
		enemie.counter = enemie.counter +1;
		
		if enemie.counter > 20 then
			enemie.speedX = 1;
			enemie.counter = 0;
			enemie.update = false;
			enemie.mode = Koopa_Mode_Normal;
		end
	end	

		--Check enemie collision with player object.
		if (object.y + object.height > enemie.y+2) and (object.y <= enemie.y) and (object.x + object.width > enemie.x) and (object.x < enemie.x + enemie.width) and object.speedY < 0 and object.jump and not object.dead and enemie.speedX > 0 then
			object.speedY = 5;
			object.jump = true;
			stomp:play();
			table.insert(scoreText, {x = enemie.x, y = enemie.y, score = 100 * multipler, display = true, counter = 0});
			object.score = object.score + scoreText[#scoreText].score;
			enemie.speedX = 0;
			multipler = multipler + 1;
			scoreCount = 0;
			enemie.Smoving = false;
			enemie.mode = Koopa_Mode_Shell;
		end
	end
	
	if enemie.jump then
		jump(enemie);
	end
	
	--Clean up 
	if enemie.y > 300 then
		table.remove(enemies, e);
		break
	elseif object.x > enemie.x + 480 then
		table.remove(enemies, e);
		break
	elseif not enemie.alive then
		table.remove(enemies, e);
		break
	end
end

		if object.dead and not musicIsPlaying then
			die:play();
			object.lives = object.lives - 1;
			musicIsPlaying = true;
		end
		
		if object.dead then
			deathCounter = deathCounter + 1;
		end
		
		if deathCounter >= 170 and State ~= Start and object.lives >= 0 then
			State = Start;
			deathCounter = 0;
		elseif deathCounter >= 170 and object.lives < 0 then
			State = GameOver;
		end
	end
end

--Function to make our objects 'Jump'
function jump(object, grav)
if not object.dead then
	grav = 0.5 or grav;
else
	grav = 0.35;
end
object.speedY = object.speedY - grav;

	if (object.speedY < 0) then
		movePlayer(object, 0, 1);
	elseif (object.speedY > 0) then
		movePlayer(object, 0, -1);
	end
end

--Function for Checkpoint system
function CheckIfObjectHasPassedCheckpoint(object)
object = player or object 
if #Checkpoint > 0 then
	for c = 1,table.getn(Checkpoint) do
		if object.x + object.width >= Checkpoint[c].x and Checkpoint[c].x <= object.x + object.width then
			Checkpoint[c].done = true
		end
		
			if Checkpoint[c].done then
				cp = Checkpoint[c];
			end
		end
	end
end

--Function to animate the player, made by myself. from a mini-lib i wrote
function pge.gfx.animateadvanced(ATime, MaxTimePerFrame, SFrame, EFrame, Constant)
Constant = Constant;  ---wheter to keep doing the animation or not.
local bool = true; 
	if bool then  
		ATime.AnimTime = ATime.AnimTime+1;  ---increase time.

		if ATime.AnimTime >= MaxTimePerFrame then   ---if more than MaxTimePerFrame then reset time, add 1 to the startiong frame. hence animation
			ATime.AnimTime = 0;
			SFrame.startFrame = SFrame.startFrame+1;
			
			if Constant and SFrame.startFrame >= EFrame.endFrame  then   ---if constant & we've reached the last frame then reset it.
				SFrame.startFrame = SFrame.oldFrame;   
			elseif not Constant then  ----if not constant then when anim finishes, stop animating.
				ATime.AnimTime = 0;
				SFrame.startFrame = -1;
			end
		end
	end
end

--Function to make our player 'Fall'
function fall(object, collisionmap)
collisionmap = layer2;
	if not object.jump then
		getObjectCorners(object.x, object.y +1, object);
			if (collisionmap[down][left] == 0 and collisionmap[down][right] == 0) then
				object.speedY = -0.5;
				object.jump = true;
		    end
	  end
end

--Function to call main PGE functions at start-up.
function startMainFunctions()
	pge.controls.update();
	pge.gfx.startdrawing();
	pge.gfx.clearscreen();
end

function animateMainChar(object)
object = player or object;
local animate = false;

--if not doing anything reset the offset
if not object.dead then
	if not animate then		
		currentSpirteEnd = 15;
		offset = 0;
	
	if direction == Right then
		currentSpirte = StandingR;
		currentSpirteEnd = 15;
		offset = 0;
	elseif direction == Left then
		currentSpirte = StandingL;
		currentSpirteEnd = 15;
		offset = 0;
	end
	
	--if jumping then change sprite.
	if object.jump then
		if direction == Right then
			currentSpirte = JumpingR;
			currentSpirteEnd = 19;
			offset = 8;
		elseif direction == Left then
			currentSpirte = JumpingL;
			currentSpirteEnd = 19;
			offset = 12;
		end
	end
end
	
	--if turning then change to turning sprite 
	if turning then
		if direction == Left then
			currentSpirte = TurningLeft;
			offset = 19;
			currentSpirteEnd = 16;
		elseif direction == Right then
			currentSpirte = TurningRight;
			offset = 18;
			currentSpirteEnd = 16;
		end
	end
	
	--if win, then change to flag animation;
	if object.win then
		if direction == Right then
			currentSpirte = GrapRight;
			offset = 20;
			currentSpirteEnd = 15;
		elseif direction == Left then
			currentSpirte = GrapLeft;
			offset = 20;
			currentSpirteEnd = 15;
		end
	end

--if pressing right then animate
	if pge.controls.held(PGE_CTRL_RIGHT) or pge.controls.analogx() > 99 then
		if not object.jump and not turning and not object.win then
			pge.gfx.animateadvanced(MarioAnimRight, MaxTime, MarioAnimRight, MarioAnimRight, true);
			currentSpirte = MarioAnimRight.startFrame;
			animate = true;
		end
	end
	--if pressing left then animate
	if pge.controls.held(PGE_CTRL_LEFT) or pge.controls.analogx() < -99 then
		if not object.jump and not turning and not object.win then
			pge.gfx.animateadvanced(MarioAnimLeft, MaxTime, MarioAnimLeft, MarioAnimLeft, true);
			currentSpirte = MarioAnimLeft.startFrame;
			animate = true;
		end
	end 
	
	--drifferent size spirtes, so i manual set the offset & end so that it doesn't clip half of the image. Not my fault but it is ugly.
	if currentSpirte == 2 then
		offset = 0;
		currentSpirteEnd = 15;		
	elseif currentSpirte == 3 then
		offset = 0;
		currentSpirteEnd = 16;
	elseif currentSpirte == 4 then
		offset = 1;
		currentSpirteEnd = 18;
	elseif currentSpirte == 5 then
		offset = 4;
		currentSpirteEnd = 15;
	elseif currentSpirte == 6 then
		offset = 3;
		currentSpirteEnd = 17;
	elseif currentSpirte == 7 then
		offset = 5;
		currentSpirteEnd = 18;
end

else
		currentSpirte = Dead;
		offset = 16;
		currentSpirteEnd = 17;
	end
end	

--Function to draw a Map
function DrawMap(object, grav)
object = player or object;
grav = 0.35 or grav;
--Set the blitting target
texture:settarget();
--Draws background
pge.gfx.clearscreen(backCol);
--Activates our tilesheet
tilesheet:activate();

	if currentFrame == frameSkip then
		TileOnY = pge.math.floor(scr_top/tsize);
		TileOnScreenH = pge.math.floor(TileOnY + 272/tsize+1);
		TileOnX = pge.math.floor(scr_left/tsize);
		TileOnScreenW = pge.math.floor(TileOnX + 480/tsize+1);
	
		if TileOnScreenW > mapX then
			TileOnScreenW = mapX;
		end
		if TileOnScreenH > mapY then
			TileOnScreenH = mapY;
		end

		local y, x, tile, X, Y;
		
	for y = TileOnY+1,TileOnScreenH do
		for x = TileOnX+1,TileOnScreenW do
			tile = map[y][x].Type;	
			--draw tiles
			if tile > 0 then
				tilesheet:draw(map[y][x].x-scr_left,map[y][x].y-scr_top, tsize, tsize, tile * tsize, (pge.math.floor(tile/maxTilesPerRow)) * tsize, tsize, tsize, 0, 255);
			end
			--Update brick block tiles if hit by small mario
			if tile == 4 then
				if map[y][x].hit then
					map[y][x].speedY = map[y][x].speedY - grav;
					map[y][x].y = map[y][x].y - map[y][x].speedY;
				end
			
				if map[y][x].y > map[y][x].oldY then
					map[y][x].speedY = 0;
					map[y][x].y = map[y][x].oldY;
					map[y][x].hit = false;
				end
			end
		end
	end
		
	if #miniBlocks > 0 then
		for b, block in ipairs(miniBlocks) do
			drawObject(block.x-scr_left, block.y-scr_top, block.img);
		end
	end
	
	if #coins > 0 then
		for c, coin in ipairs(coins) do
			if object.x + 480 > coin.x and coin.display then
				drawObjectAdvanced(Coins, coin.x-scr_left, coin.y-scr_top, coin.width, coin.height, (coin.startFrame * coin.width), 0, coin.width, coin.height);
			elseif object.x + 480 < coin.x then
				coin.display = false;
				break;
			end
		end
	end
	
	--draw mini coin
	drawObjectAdvanced(miniCoins, 125, 27, 7, 10, MiniCoins.startFrame * 7, 0, 7, 10);
	
	--draw flag
	if object.x + 480 > flag[1].x then
		drawObjectAdvanced(tilesheet, (flag[1].x)-scr_left,(flag[1].y)-scr_top, tsize, tsize, (36-(maxTilesPerRow)-1) * tsize, 16, tsize, tsize, 0, 255);
	end
	
	--draw players & enemies
	drawPlayersAndEnemies();
		
	-- Revert to drawing directly to the screen
	pge.gfx.rendertoscreen()
	texture:activate();
	texture:draweasy(0,0);
	
	if currentFrame >= frameSkip then
		currentFrame = 1;
	end
end
	    
	currentFrame = currentFrame + 1; ---increments the current frame
end

--Function to draw objects to the screen
function drawObject(X, Y, Img, R, A)
R = 0 or R;
A = 255 or A;
	pge.texture.activate(Img)
	pge.texture.draweasy(Img, X, Y, R, A);
end

--Function to draw objects to the screen, advanced.
function drawObjectAdvanced(Img, X, Y, Width, Height, StartX, StartY, EndX, EndY, R, A)
R = 0 or R;
A = 255 or A;
	pge.texture.activate(Img);
	pge.texture.draw(Img, X, Y, Width, Height, StartX, StartY, EndX, EndY, R, A);
end

--Function to print text
function debugPrint(X, Y, colour, str)	
	emulogic10:print(X, Y, colour, str);
end

--Function to draw enemies & player
function drawPlayersAndEnemies()
local tempX = math.floor(player.x);
	for i, enemie in ipairs(enemies) do
		if enemie.alive and enemie.Type == enemyTypeGoomba and player.x + 480 > enemie.x then
			drawObjectAdvanced(goomba, enemie.x-scr_left, enemie.y-scr_top, enemie.width+2, enemie.height, (enemie.startFrame * (enemie.width+2)), 0, (enemie.width+2), (enemie.height));
		end
		if enemie.alive and enemie.Type == enemyTypeKoopaGreen and player.x + 480 > enemie.x then
			drawObjectAdvanced(koopa_green, enemie.x-scr_left, enemie.y-scr_top-4, enemie.width+2, enemie.height+4, (enemie.startFrame * (enemie.width+2)), 0, (enemie.width+2), (enemie.height+4));
		end
		if enemie.alive and enemie.Type == enemyTypeKoopaRed and player.x + 480 > enemie.x then
			drawObjectAdvanced(koopa_red, enemie.x-scr_left, enemie.y-scr_top-4, enemie.width+2, enemie.height+4, (enemie.startFrame * (enemie.width+2)), 0, (enemie.width+2), (enemie.height+4));
		end
	end

	if player.jump and direction == Right then
		drawObjectAdvanced(player.img, tempX-scr_left-4, player.y-scr_top-2, currentSpirteEnd, (player.height+2), (currentSpirte * 15)+offset, 0, currentSpirteEnd, (player.height+2));
	elseif player.jump and direction == Left then
		drawObjectAdvanced(player.img, tempX-scr_left-2, player.y-scr_top-2, currentSpirteEnd, (player.height+2), (currentSpirte * 15)+offset, 0, currentSpirteEnd, (player.height+2));
	else
		drawObjectAdvanced(player.img, tempX-scr_left, player.y-scr_top-2, currentSpirteEnd, (player.height+2), (currentSpirte * 15)+offset, 0, currentSpirteEnd, (player.height+2));
	end
end

--Function to update/draw/ animation blocks & mini-blocks
function updateBlocks(grav, object)
grav = 0.5 or grav;
object = player or object;
local maxTime = 14;

	if #miniBlocks > 0 then
		for b, block in ipairs(miniBlocks) do
			
			--update block postitions
			block.speedY = block.speedY - grav;
			block.y = block.y - block.speedY;
			block.x = block.x + block.speedX;
			
			if block.y > 300 then
				table.remove(miniBlocks, b);
				break;
			end
		end
	end
	
	if #animBlocks > 0 then
		for i, anim in ipairs(animBlocks) do
			if object.x + 480 > anim.x and map[anim.y][anim.x].Type ~= BlankBlock then
				pge.gfx.animateadvanced(anim, maxTime, anim, anim, true);
				map[anim.y][anim.x].Type = anim.startFrame;
			else
				table.remove(animBlocks, i);
				break;
			end
		end
	else
	end
end

--Function to update the timer, it also handles the warning sound when time is low & kill mario if the time is <= 0.
function updateTime(maxTime, object)
object = player or object;
maxTime = 400 or maxTime;
local death = false;
totalTime = math.floor(maxTime - (current.Time:peekdelta()));

	if totalTime <= 0 or object.y > 280 then
		death = true;
	end
	
	if totalTime == 70 and not warningPlayed then
		warning:play();
		warningPlayed = true;
	end
	
	if death and not object.dead then
		object.speedY = 10;
		object.jump = true;
		object.dead = true;
	else
		death = false;
	end
end

--Function to update/render/clean-up the score 
function updateScore()
	if #scoreText > 0 then
		scoreCount = scoreCount + 1;
			
	if scoreCount > 50 then
			scoreCount = 0;
			multipler = 1;
	end
			
		for s, score in ipairs(scoreText) do
			score.counter = score.counter + 1;
				
			if score.counter > 50 then
				score.display = false;
			else
				score.y = score.y - 0.1;
			end
			
			if score.display then
				debugPrint(score.x-scr_left, score.y-scr_top, white, score.score);
			end
			--clean-up
			if not score.display then
				table.remove(scoreText, s);
				break;
			end
		end
	end
end

--Function to update/render/clean-up coins
function updateCoins(object)
local maxTime = 8;
object = player or object;

	if #coins > 0 then
		for c, coin in ipairs(coins) do
			if object.x + 480 > coin.x and coin.display then
				--animate coins
				pge.gfx.animateadvanced(coin, maxTime, coin, coin, true);
			end
			
			if object.x + 480 > coin.x and coin.display and coin.hit then
				coin.counter = coin.counter + 1;
				coin.speedY = coin.speedY - 0.06;
				coin.y = coin.y - coin.speedY;
				
				if coin.counter > 32 then
					coin.display = false;
				end
			end
			
			if object.x > coin.x + 480 then
				coin.display = false;
			end
			
			--clean-up
			if not coin.display then
				table.remove(coins, c);
				break;
			end
		end
	else
	end
end
				
--Function to update/render the HUD 
function updateHUD()
local maxTime = 10;
	--animate mini coin
	pge.gfx.animateadvanced(MiniCoins, maxTime, MiniCoins, MiniCoins, true);
	--activate the font
	emulogic10:activate();
	if playerChose == 0 then
		debugPrint(45, 20, white, "MARIO");
	elseif playerChose == 1 then
		debugPrint(45, 20, white, "LUIGI");
	end
	debugPrint(45, 30, white, ""..player.score);
	debugPrint(135, 30, white, "x "..player.coins);
	debugPrint(230, 20, white, "WORLD");
	debugPrint(230, 30, white, current.level);
	debugPrint(350, 20, white, "TIME");
	debugPrint(350, 30, white, ""..totalTime);
end

--Function to reset Values
function Reset(object)
object = player or object;
	--reset values back to starting positions
	direction = Right;
	object.x = 32;
	object.y = 0;
	object.win = false;
	table.remove(Checkpoint);
	table.remove(animBlocks);
	table.remove(enemies);
	table.remove(flag);
end

--Function to check the current Gamestate & call certain functions
function checkState(nextLvl, object)
object = player or object;
	if State == Start then
		splashCounter = splashCounter + 1;
		totalTime = 400;
		scr_left = 0;
		scr_top = 0;
		object.dead = false;
		musicIsPlaying = false;
		warningPlayed = false;
		current.Time = pge.timer.create();
		scoreCount = 0;
		deathCounter = 0;
		direction = Right;
			
	if #Checkpoint > 0 then
		for c = 1, #Checkpoint do
			if Checkpoint[c].done then
				object.x = cp.x + object.width;
				object.y = 20;
				object.speedY = 0;
				
				if scr_left > (#map[1] * tsize - 480) then
					scr_left = (#map[1] * tsize - 480);
					break;
				else
					scr_left = cp.x;
					break;
				end
				
			end
		end
	else
		object.x = 10;
		object.y = 20;
		object.speedY = -1;
		scr_left = 0;
	end
		
		--activate the font
		emulogic10:activate();
		debugPrint(210, 130, white, " X "..object.lives);
		drawObjectAdvanced(object.img, 195, 122, 15, object.height, (StandingR * 15), 0, 15, object.height);
	
		if splashCounter >= 50 then
			State = Play;
			splashCounter = 0;
		end
	end
	
	if State == Play then
		detectButtons(player);
		animateMainChar();	
		updateAi(); 
		updateCoins();
		updateTime();
		updateBlocks();
		CheckIfObjectHasPassedCheckpoint();
		
		if object.win then
			object.x = flag[1].x + 5;
		
		if object.y >= 208 then
		else
			object.y = object.y + 1.3;
		end
		
		if flag[1].y > (object.y) then
			object.x = flag[1].x + 18;
			current.levelNum = current.levelNum + 1;
			current.level = "1-"..current.levelNum;
			Reset();
			State = Start;
			dofile(nextLvl);
		else
			flag[1].y = flag[1].y + 1;
		end

	table.sort(enemies, 
		function(a,b) 
			return a.x<b.x;
		end
	);
end
	
		if pge.controls.pressed(PGE_CTRL_START) then
			State = Pause;
			pause:play();
		end
	end
	
	if State ~= Start and State ~= GameOver then
		DrawMap();
	end
	
	if State == GameOver then
		gameOverCounter = gameOverCounter + 1;
		debugPrint(200, 126, white, "GAME OVER");
		
		if not gameOverPlayed then
			gameover:play();
			gameOverPlayed = true;
		end
		
		if gameOverCounter > 200 then
			gameOverCounter = 0;
			texture = nil;
			restart();
		end
	end
	
	if State == Pause then
		if pge.controls.pressed(PGE_CTRL_START) then
			State = Play;
		end
	end
end

--Function to create a screenshot of the screen ("for Debugging")
function debugShot()
	if pge.controls.pressed(PGE_CTRL_SELECT) then
		screeNum = screeNum + 1;
		pge.gfx.screenshot("Screenie"..screeNum..".jpeg");
	end
end

--Function to call ending PGE functions at the end of each loop.
function endMainFunctions()
	pge.gfx.enddrawing();
	pge.gfx.swapbuffers();
end
